//
// PathTest.h
//
// $Id: //poco/1.4/Foundation/testsuite/src/PathTest.h#2 $
//
// Definition of the PathTest class.
//
// Copyright (c) 2004-2006, Applied Informatics Software Engineering GmbH.
// and Contributors.
//
// Permission is hereby granted, free of charge, to any person or organization
// obtaining a copy of the software and accompanying documentation covered by
// this license (the "Software") to use, reproduce, display, distribute,
// execute, and transmit the Software, and to prepare derivative works of the
// Software, and to permit third-parties to whom the Software is furnished to
// do so, all subject to the following:
// 
// The copyright notices in the Software and this entire statement, including
// the above license grant, this restriction and the following disclaimer,
// must be included in all copies of the Software, in whole or in part, and
// all derivative works of the Software, unless such copies or derivative
// works are solely in the form of machine-executable object code generated by
// a source language processor.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
// SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
// FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.
//


#ifndef PathTest_INCLUDED
#define PathTest_INCLUDED


#include "Poco/Foundation.h"
#include "CppUnit/TestCase.h"


class PathTest: public CppUnit::TestCase
{
public:
	PathTest(const std::string& name);
	~PathTest();

	void testParseUnix1();
	void testParseUnix2();
	void testParseUnix3();
	void testParseUnix4();
	void testParseUnix5();
	void testParseWindows1();
	void testParseWindows2();
	void testParseWindows3();
	void testParseWindows4();
	void testParseVMS1();
	void testParseVMS2();
	void testParseVMS3();
	void testParseVMS4();
	void testParseGuess();
	void testTryParse();
	void testStatics();
	void testBaseNameExt();
	void testAbsolute();
	void testRobustness();
	void testParent();
	void testForDirectory();
	void testExpand();
	void testListRoots();
	void testFind();
	void testSwap();
	void testResolve();
	void testPushPop();

	void setUp();
	void tearDown();

	static CppUnit::Test* suite();

private:
};


#endif // PathTest_INCLUDED
